import ConfigParser, os
class config():	


	def __init__(self, section):
		self.section = section
		self.config = ConfigParser.SafeConfigParser()

		try:
		
			self.refresh()
		
		except ConfigParser.NoSectionError:
			
			self.config.add_section(self.section)
			self.refresh()

		

	def get_option(self, option):
		return self.config.get(self.section, option)
	
	def get(self):
		return self.conf
		
	def refresh(self,rld=True):
		if rld:
			self.config.read(os.path.expanduser("~/.blueman/blueman.conf"))
		
		ls = self.config.items(self.section)
		self.conf = []
		
		for i in range(len(ls)):
			self.conf.append((ls[i][0].replace("-",":"),ls[i][1]))
		  
		  
	def add_unique(self, key, name):
		
		option = key.replace(":","-")
		
		curr = self.get()
		for i in range(len(curr)):
			if curr[i][0].upper() == key:
				return False
		
		self.config.set(self.section, option, name)
		
	
	def add(self, key, val):
		key = key.replace(":","-")
		self.config.set(self.section, key, str(val))
	
	def delete(self, addr):
		addr = addr.replace(":","-")
		self.config.remove_option(self.section, addr)
		

	def save(self):
		if not os.path.exists(os.path.expanduser("~/.blueman")):

			os.mkdir(os.path.expanduser("~/.blueman"))
		
		
		fp = open(os.path.expanduser("~/.blueman/blueman.conf"),"w")
		self.config.write(fp)
		fp.close()
		self.refresh()
		
		
class cache(config):
	def push(self, addr, name):
		try:
			self.delete(addr)
		except:
			pass


		#print "cache: adding %s %s" % (addr, name)
		self.add(addr, name)
		
		self.refresh(False)
		self.save()
		
	def pull(self, addr):
		try:
			addr2 = addr.replace(":","-")
			return self.get_option(addr2)
		except:
			return False
